﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Xml.Serialization;
using System.IO;


namespace DemoCurvas
{
    public partial class frmMain : Form
    {
        public const int MAX_CANT_CURVAS = 30;
        public const int MAX_TIEMPO = 19;
        public const int THREAD_DELAY = 300;
        
        System.Threading.Thread threadChart1;
        private int Interval = 300;
        Timer clock = null;

        public frmMain(ref Hashtable CommandLineArgs)
        {
            InitializeComponent();

            InitializeScreen(CommandLineArgs);

            InitializeChart( tChart1 );

            threadChart1= new System.Threading.Thread(new System.Threading.ThreadStart(FillSeriesChart1));
            threadChart1.Start();

            this.textBox1.Font = new Font("Verdana", tChart1.Chart.Axes.Left.Labels.Font.Size, FontStyle.Bold);
            this.textBox2.Font = new Font("Verdana", tChart1.Chart.Axes.Left.Labels.Font.Size, FontStyle.Bold);
            this.textBox3.Font = new Font("Verdana", tChart1.Chart.Axes.Left.Labels.Font.Size, FontStyle.Bold);
            this.textBox4.Font = new Font("Verdana", tChart1.Chart.Axes.Left.Labels.Font.Size, FontStyle.Bold);
            this.textBox5.Font = new Font("Verdana", tChart1.Chart.Axes.Left.Labels.Font.Size, FontStyle.Bold);
            this.textBox6.Font = new Font("Verdana", tChart1.Chart.Axes.Left.Labels.Font.Size, FontStyle.Bold);
            this.textBox7.Font = new Font("Verdana", tChart1.Chart.Axes.Left.Labels.Font.Size, FontStyle.Bold);
            this.textBox8.Font = new Font("Verdana", tChart1.Chart.Axes.Left.Labels.Font.Size, FontStyle.Bold);
        }

        private void InitializeScreen(Hashtable CommandLineArgs)
        {
            this.Width = Screen.AllScreens[0].WorkingArea.Width;
            this.Height = Screen.AllScreens[0].WorkingArea.Height;

            foreach( string key in CommandLineArgs.Keys)
            {
                #region Width
                if (key == "/w")
                {
                    try
                    {
                        this.Width = Convert.ToInt32(CommandLineArgs[key]);
                    }
                    catch
                    {
                        this.Width = Screen.AllScreens[0].WorkingArea.Width;
                    }
                }
                #endregion
                #region Height
                if (key == "/h")
                {
                    try
                    {
                        this.Height = Convert.ToInt32(CommandLineArgs[key]);
                    }
                    catch
                    {
                        this.Height = Screen.AllScreens[0].WorkingArea.Height;
                    }
                }
                #endregion
                #region Display
                if (key == "/d")
                {
                    try
                    {
                        this.Left = Screen.AllScreens[Convert.ToInt32(CommandLineArgs[key])].WorkingArea.X;
                        this.Top = Screen.AllScreens[Convert.ToInt32(CommandLineArgs[key])].WorkingArea.Y;
                    }
                    catch
                    {
                        this.Left = 0;
                        this.Top = 0;

                    }
                }
                #endregion            
                #region Refresh interval
                if (key == "/r")
                {
                    try
                    {
                        this.Interval = Convert.ToInt32(CommandLineArgs[key]);
                    }
                    catch
                    {
                        this.Interval = 300;
                    }
                }
                #endregion
            }


            this.splitContainer1.SplitterDistance = this.splitContainer1.Height - textBox1.Height-15;

        }

        private void InitializeChart(Steema.TeeChart.TChart chart)
        {
            chart.AutoRepaint = false;

            chart.Chart.Axes.Left.AxisPen.Width = 1;
            chart.Chart.Axes.Left.AxisPen.Color = Color.FromArgb(54, 54, 54);
            chart.Chart.Axes.Left.Grid.Style = System.Drawing.Drawing2D.DashStyle.Solid;
            chart.Chart.Axes.Left.Grid.Color = Color.FromArgb(54, 54, 54);
            chart.Chart.Axes.Left.Automatic = false;
            chart.Chart.Axes.Left.Minimum = -25.0;
            chart.Chart.Axes.Left.Maximum = 450.0;
            chart.Chart.Axes.Left.Labels.Font.Color = Color.White;
            chart.Chart.Axes.Left.Ticks.Length = 0;
            chart.Chart.Axes.Left.MinorTickCount = 0;
            chart.Chart.Axes.Left.MinorTicks.Length = 0;
            chart.Chart.Axes.Left.Increment = 22.5;
            chart.Chart.Axes.Left.Labels.Font.Size = (chart.Parent.Height*14)/1050;
            chart.Chart.Axes.Left.Labels.Font.Name = "Verdana";
            chart.Chart.Axes.Left.Labels.Font.Bold = true;
            chart.Chart.Axes.Left.Labels.ValueFormat= "####0.0##";

            chart.Chart.Axes.Bottom.AxisPen.Width = 1;
            chart.Chart.Axes.Bottom.AxisPen.Color = Color.FromArgb(54, 54, 54);
            chart.Chart.Axes.Bottom.Grid.Style = System.Drawing.Drawing2D.DashStyle.Solid;
            chart.Chart.Axes.Bottom.Grid.Color = Color.FromArgb(54, 54, 54);
            chart.Chart.Axes.Bottom.Automatic = false;
            chart.Chart.Axes.Bottom.Minimum = 0.0;
            chart.Chart.Axes.Bottom.Increment = 1.0;
            chart.Chart.Axes.Bottom.Maximum = MAX_TIEMPO;
            chart.Chart.Axes.Bottom.Labels.Font.Color = Color.White;
            chart.Chart.Axes.Bottom.Ticks.Length = 0;
            chart.Chart.Axes.Bottom.MinorTickCount = 0;
            chart.Chart.Axes.Bottom.MinorTicks.Length = 0;
            chart.Chart.Axes.Bottom.Labels.Font.Size = (chart.Parent.Height * 14)/1050;
            chart.Chart.Axes.Bottom.Labels.Font.Name = "Verdana";
            chart.Chart.Axes.Bottom.Labels.Font.Bold = true;
            chart.Chart.Axes.Bottom.Labels.ValueFormat = "####0.0##";

        }
            
        private void frmMain_Load(object sender, EventArgs e)
        {
            clock = new Timer();
            clock.Interval = this.Interval;
            clock.Tick += new EventHandler(clock_Tick);
            clock.Start();
        }

        void clock_Tick(object sender, EventArgs e)
        {
               tChart1.Refresh();
        }

        public void FillSeriesChart1()
        {
            double[,] valores = new double[MAX_CANT_CURVAS,5000];

            #region Read sample data from csv file
            StreamReader sr = new StreamReader("tChart1.csv");
            string linea = "";
            int nElementos = 0;
            int nCurva = 0;
            string[] elementos = null;
            int i;
            while ((linea = sr.ReadLine()) != null)
            {
                elementos = linea.Split(',');
                nElementos = elementos.Length;

                for (i = 0; i < nElementos; i++)
                {
                    valores[nCurva, i] = Convert.ToDouble(elementos[i]);
                }

                tChart1.Series.Add(new Steema.TeeChart.Styles.FastLine());
                Steema.TeeChart.Styles.FastLine serie = (Steema.TeeChart.Styles.FastLine)tChart1.Series[nCurva];
                serie.DrawAllPoints = false;
                nCurva++;
            }
            sr.Close();
            #endregion

            int nMuestras = (int)(((nElementos / MAX_TIEMPO) * THREAD_DELAY) / 1000.0);
            double incremento = (double)MAX_TIEMPO / (double)nElementos;
            int posVector = 0, j = 0;
            double posX=0, x = 0;
            int posFinal = nElementos - (nElementos % nMuestras) -100;
            i = 0;
            while (true)
            {


                for (i = 0; i < nCurva; i++)
                {

                    for (j = posVector, x = posX; j < posVector + nMuestras; j++, x = x + incremento)
                        tChart1.Series[i].Add(x, valores[i, j]);


                    tChart1.Series[i].RefreshSeries();

                }

                posVector += nMuestras;
                posX = x;

                if (posVector >= posFinal)
                {
                    posX = posVector = 0;
                    x = 0;
                    for (i = 0; i < nCurva; i++){
                        tChart1.Series[i].Clear();
                    }
                }

                System.Threading.Thread.Sleep(THREAD_DELAY);
            }
        }

        private void frmMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            threadChart1.Abort();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void splitContainer1_Panel2_Paint(object sender, PaintEventArgs e)
        {

        }

        private void txtOP_TextChanged(object sender, EventArgs e)
        {
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void splitContainer1_Panel2_Paint_1(object sender, PaintEventArgs e)
        {

        }

    }
}
